/* $Id: sparc_ksyms.c,v 1.13 1996/09/04 22:51:11 davem Exp $
 * arch/sparc/kernel/ksyms.c: Sparc specific ksyms support.
 *
 * Copyright (C) 1996 David S. Miller (davem@caip.rutgers.edu)
 * Copyright (C) 1996 Eddie C. Dost (ecd@skynet.be)
 */

#include <linux/config.h>
#include <linux/module.h>
#include <linux/types.h>
#include <linux/string.h>

#include <asm/oplib.h>
#include <asm/delay.h>
#include <asm/system.h>
#include <asm/auxio.h>
#include <asm/pgtable.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/idprom.h>
#include <asm/svr4.h>
#include <asm/head.h>
#include <asm/smp.h>
#include <asm/mostek.h>
#include <asm/ptrace.h>
#include <asm/user.h>
#ifdef CONFIG_SBUS
#include <asm/sbus.h>
#endif

extern int active_ds; /* from process.c */

extern int svr4_setcontext (svr4_ucontext_t *, struct pt_regs *);
extern unsigned long sunos_mmap(unsigned long, unsigned long, unsigned long,
				unsigned long, unsigned long, unsigned long);

extern void bcopy (const char *, char *, int);
extern int __ashrdi3(int, int);

extern void dump_thread(struct pt_regs *, struct user *);

/* One thing to note is that the way the symbols of the mul/div
 * support routines are named is a mess, they all start with
 * a '.' which makes it a bitch to export, here is the trick:
 */
#define DD(sym) extern int __sparc_dot_ ## sym (int) __asm__("." ## #sym)
#define XD(sym) { (void *) & __sparc_dot_ ## sym, "." ## #sym }

DD(rem);
DD(urem);
DD(div);
DD(udiv);
DD(mul);
DD(umul);

static struct symbol_table arch_symbol_table = {
#include <linux/symtab_begin.h>

	/* used by various drivers */
	X(sparc_cpu_model),
	X(active_ds),
#ifdef __SMP__
	X(kernel_flag),
	X(kernel_counter),
	X(active_kernel_processor),
	X(syscall_count),
#endif

	X(udelay),
	X(mstk48t02_regs),
#if CONFIG_SUN_AUXIO
	X(auxio_register),
#endif
	X(request_fast_irq),
	X(sparc_alloc_io),
	X(sparc_free_io),
	X(mmu_unlockarea),
	X(mmu_lockarea),
	X(SBus_chain),

	/* Solaris/SunOS binary compatibility */
	X(svr4_setcontext),
	X(sunos_mmap),

	/* Should really be in linux/kernel/ksyms.c */
	X(dump_thread),

	/* prom symbols */
	X(idprom),
	X(prom_root_node),
	X(prom_getchild),
        X(prom_getsibling),
	X(prom_searchsiblings),
        X(prom_nextprop),
	X(prom_getproplen),
	X(prom_getproperty),
        X(prom_setprop),
        X(prom_nodeops),
	X(prom_getbootargs),
	X(prom_apply_obio_ranges),

	/* sparc library symbols */
	X(bcopy),
	X(memmove),
	X(memscan),
	X(strlen),
	X(strnlen),
	X(strcpy),
	X(strncpy),
	X(strcat),
	X(strncat),
	X(strcmp),
	X(strncmp),
	X(strchr),
	X(strrchr),
	X(strpbrk),
	X(strtok),
	X(strstr),
	X(strspn),

	/* No version information on these, as gcc produces such symbols. */
	XNOVERS(memcmp),
	XNOVERS(memcpy),
	XNOVERS(memset),
	XNOVERS(__ashrdi3),

	XD(rem),
	XD(urem),
	XD(mul),
	XD(umul),
	XD(div),
	XD(udiv),
#include <linux/symtab_end.h>
};

void arch_syms_export(void)
{
	register_symtab(&arch_symbol_table);
#if CONFIG_AP1000
	ap_register_ksyms();
#endif
}
